##Create Section Drawings and export.
require 'sketchup.rb'
class TAK_MSS
def version_infos()
###read me.
{
"Name" => "Create Section Drawings and export.",
"Author" => "TAK2HATA",
"Description" => "Select the section plane and pulldown menu \"Create Section Drawing\".
#And The section will be created in the component definition list of the model.
#and export to \"DrawingSection\" folder as skp and dxf.
#The section from solid will be filled.
#The infomation of component or group will add text to drawings.(name,and BST info)
#The ComponentDefinition named \"BST_BASELINES\" will add baselines to drawings.",

"Notice" =>"Strongly Recommend Sketchup version 8 higher for using this.
The copyright of this plug-in is in TAK2HATA. 
Please use this plug-in in self-responsibility. 
I do not take any responsibility. 
You can use freely. ",

"Notice(JP)" =>"免責事項：このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
このスクリプトの著作権はTAK2HATAにあるものとします。
ただし商用（販売など）の目的でない場合はご自由にお使いください。
改変も自由ですが、配布の際はTAK2HATAまでご連絡ください。下記にブログのアドレスを掲示します。
 http://ameblo.jp/onigiri-burning/
改変開発者の方へ：デフォルト値保存やクラス名など、名称が被らないようにご配慮お願いいたします。",

"Version" => "1.3(Dec 16,2012)",

"History" => "#Apr 16.2012:First test
#Apr 17.2012:modified.切断面と交差しないソリッドは考慮しないようにして高速化を図っている（検討中）
#Apr 22.2012:Improves and BugFix.
#Apr 23.2012:Add DXF export
#May 02.2012:v1.0 Fisrt release.
#May 06.2012:v1.1 Bugfix about calculating baselines on mac.
#Jun 28.2012:v1.2 Improve about dxf value scaling by units in sketchup.
#Dec 16.2012:v1.3 The drawings is added the text about Distance of SectionPlane.
",

"Others" => "
 Where download My Building Smart Modeling tool for sketchup
 Hole on Solid Tool
 http://forums.sketchucation.com/viewtopic.php?f=323&t=41582
 Building structure tool
 http://forums.sketchucation.com/viewtopic.php?f=323&t=35798
 Solid quantify
 http://forums.sketchucation.com/viewtopic.php?f=323&t=41120
 WHD Parametric Component
 Coming soon." }
end
def show_about_this()
bvi = version_infos
msg = "Name:#{bvi[ "Name" ]}
Author:#{bvi[ "Author" ]}
Version:#{bvi[ "Version" ]}
Notice:#{bvi[ "Notice" ]}"
UI.messagebox msg
end
	def get_all_entities( parent , tr , linelist , facelist , textlist , polylist , layerlist )
		if parent.kind_of? Sketchup::ComponentDefinition
			ents = parent.entities
			gname = parent.name.gsub( "[SOLIDSECTION]" ,"" )
		elsif parent.kind_of? Sketchup::Group
			ents = parent.entities
			gname = parent.name.gsub( "[SOLIDSECTION]" ,"" )
		end
		gname.gsub!(/\W/,"_")
		ents.each{|ent|
			if ent.visible? == true and ent.layer.visible? == true
				if ent.kind_of? Sketchup::ComponentInstance
					get_all_entities( ent.definition , tr * ent.transformation , linelist , facelist , textlist , polylist , layerlist )
				elsif ent.kind_of? Sketchup::Group
					get_all_entities( ent , tr * ent.transformation , linelist , facelist , textlist , polylist , layerlist )
				elsif ent.kind_of? Sketchup::Face
					gname2 = gname + "_FILL"
					layerlist.push [ gname2 , "9" , "CONTINUOUS" ] if layerlist.assoc( gname2 ) == nil
					facelist.push [ ent , tr , gname2 ]
				elsif ent.kind_of? Sketchup::Edge
					gname2 = gname + "_LINE"
					layerlist.push [ gname2 , "3" , "CONTINUOUS" ] if layerlist.assoc( gname2 ) == nil
					linelist.push [ ent.start.position , ent.end.position , tr , gname2 ]
				elsif ent.kind_of? Sketchup::ConstructionLine
					gname2 = gname + "_CLINE"
					if ent.stipple == 7239##"-.-"
						lstyle = "CENTER"
					elsif ent.stipple == 13107##"-"
						lstyle = "HIDDEN"
					elsif ent.stipple == 61680##"_"
						lstyle = "HIDDEN"
					elsif ent.stipple == 34952##"."
						lstyle = "DOTTED"
					else
						lstyle = "CONTINUOUS"
					end
					layerlist.push [ gname2 , "1" , lstyle ]if layerlist.assoc( gname2 ) == nil
					linelist.push [ ent.start , ent.end , tr , gname2 ]
				elsif ent.kind_of? Sketchup::Text
					gname2 = ent.layer.name
					layerlist.push [ gname2 , "2" , "CONTINUOUS" ] if layerlist.assoc( gname2 ) == nil
					textlist.push [ ent , tr , gname2 ]
				end
			end
		}
	end
	def dxf_exporter( filename , cdef )
		units = 0
		Sketchup.active_model.options.each{|op|
			units = op["LengthUnit"] if op["LengthUnit"]
		}
		@units_metric = true
		if units < 2
			@units_metric = false
		end
		entityClass = "LINE"
		layername = "SKP_LINES"
		lstyle = "CONTINUOUS"
		colornum = "7"
		linelist , facelist , textlist , polylist , lylist = [] , [] , [] , [] , []
		get_all_entities( cdef , Geom::Transformation.new , linelist , facelist , textlist , polylist , lylist )
		@dxfcode = []
		dxf_header( lylist )
		facelist.each{|fc,tr,gname|
			msh = fc.mesh( 0 )
			msh.polygons.each{|poly|
				pts = poly.map{|pind| msh.point_at( pind ) }
				dxf_solid( pts , gname )
			}
		}
		linelist.each{|p0,p1,tr,gname|
			dxf_line( p0 , p1 , gname )
		}
		textlist.each{|e,tr,gname|
			textstr1 = e.text
			tpt = e.point#.transform( tr )
			#p tpt
			textstr1.split("\n").each{|textstr|
				dxf_text( textstr , tpt , gname , "100" )
				tpt.y = tpt.y - 150.mm
			}
		}

		#dxf_polyline( pts , close? = true , layername = "SKP_POLYLINE" , lstyle = "ByLayer" , colornum = "ByLayer" )
		
		#####footer
		@dxfcode << [ "0" , "ENDSEC" ]
		@dxfcode << [ "0" , "EOF" ]
		xf = File.new(filename, "w")
		Sketchup.set_status_text "exporting to" + ":" + filename
		
		@dxfcode.each{|gcode,codestr|
			xf.puts "  #{gcode}"
			xf.puts codestr
		}
		xf.close
	end
	def dxf_table( lylist )
		@dxfcode << [ "0" , "SECTION" ]
		@dxfcode << [ "2" , "TABLES" ]
		@dxfcode << [ "0","TABLE" ]
		@dxfcode << [ "2","LTYPE" ]
		@dxfcode << [ "70","5" ]
		@dxfcode << [ "0","LTYPE" ]
		@dxfcode << [ "2","CONTINUOUS" ]
		@dxfcode << [ "70","0" ]
		@dxfcode << [ "3","Solid line" ]
		@dxfcode << [ "72","65" ]
		@dxfcode << [ "73","0" ]
		@dxfcode << [ "40","0.0" ]
		@dxfcode << [ "0","LTYPE" ]
		@dxfcode << [ "2","CENTER" ]
		@dxfcode << [ "70","0" ]
		@dxfcode << [ "3","Center _____  _  _____  _  _____  _  _____  _ " ]
		@dxfcode << [ "72","65" ]
		@dxfcode << [ "73","4" ]
		@dxfcode << [ "40","50.8" ]
		@dxfcode << [ "49","31.75" ]
		@dxfcode << [ "49","-6.35" ]
		@dxfcode << [ "49","6.35" ]
		@dxfcode << [ "49","-6.35" ]
		@dxfcode << [ "0","LTYPE" ]
		@dxfcode << [ "2","DASHED" ]
		@dxfcode << [ "70","0" ]
		@dxfcode << [ "3","Dashed __ __ __ __ __ __ __ __ __ __ __ __ __ " ]
		@dxfcode << [ "72","65" ]
		@dxfcode << [ "73","2" ]
		@dxfcode << [ "40","0.375" ]
		@dxfcode << [ "49","0.25" ]
		@dxfcode << [ "49","-0.125" ]
		@dxfcode << [ "0","LTYPE" ]
		@dxfcode << [ "2","DOTTED" ]
		@dxfcode << [ "70","0" ]
		@dxfcode << [ "3","Dotted . . . . . . . . . . . . . . . . . . . ." ]
		@dxfcode << [ "72","65" ]
		@dxfcode << [ "73","2" ]
		@dxfcode << [ "40","0.25" ]
		@dxfcode << [ "49","0.0" ]
		@dxfcode << [ "49","-0.25" ]
		@dxfcode << [ "0","LTYPE" ]
		@dxfcode << [ "2","HIDDEN" ]
		@dxfcode << [ "70","0" ]
		@dxfcode << [ "3","Hidden _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _" ]
		@dxfcode << [ "72","65" ]
		@dxfcode << [ "73","2" ]
		@dxfcode << [ "40","0.375" ]
		@dxfcode << [ "49","0.25" ]
		@dxfcode << [ "49","-0.125" ]
		@dxfcode << [ "0","ENDTAB" ]
		
		@dxfcode << [ "0" , "TABLE" ]
		@dxfcode << [ "2" , "LAYER" ]
		@dxfcode << [ "70" , "1" ]
		lylist.each{|ly,cl,styl|
			@dxfcode << [ "0" , "LAYER" ]
			@dxfcode << [ "2" , "#{ly}" ]
			@dxfcode << [ "70" , "0" ]
			@dxfcode << [ "62" , "#{cl}" ]
			@dxfcode << [ "6" , "#{styl}" ]
		}
		@dxfcode << [ "0" , "ENDTAB" ]
	end
	def dxf_header( lylist )
		###HEADER SECTION
		@dxfcode << [ "0" , "SECTION " ]
		@dxfcode << [ "2" , "HEADER " ]
		@dxfcode << [ "9" , "$ACADVER " ]
		@dxfcode << [ "1" , "AC1009" ]
		@dxfcode << [ "9" , "$UCSORG " ]
		@dxfcode << [ "10" , "0.0 " ]
		@dxfcode << [ "20" , "0.0 " ]
		@dxfcode << [ "30" , "0.0 " ]
		@dxfcode << [ "9" , "$UCSXDIR " ]
		@dxfcode << [ "10" , "1.0 " ]
		@dxfcode << [ "20" , "0.0" ]
		@dxfcode << [ "30" , "0.0" ]
		@dxfcode << [ "9" , "$TILEMODE"]
		@dxfcode << [ "70" , "1" ]
		@dxfcode << [ "9" , "$UCSYDIR" ]
		@dxfcode << [ "10" , "0.0" ]
		@dxfcode << [ "20" , "1.0" ]
		@dxfcode << [ "30" , "0.0" ]
		@dxfcode << [ "9" , "$EXTMIN" ]
		@dxfcode << [ "10" , "-42000.00" ]
		@dxfcode << [ "20" , "-29700.00" ]
		@dxfcode << [ "30" , "0.00" ]
		@dxfcode << [ "9" , "$EXTMAX" ]
		@dxfcode << [ "10" , "42000.00" ]
		@dxfcode << [ "20" , "29700.00" ]
		@dxfcode << [ "30" , "0.00" ]
		#Units of length
		@dxfcode << [ "9" , "$LUNITS" ]
		#if @units_metric == true
			@dxfcode << [ "70" , "2" ]
		#else
		#	@dxfcode << [ "70" , "4" ]
		#end
		#4 as architectural
		#2 as decimal
		@dxfcode << [ "0" , "ENDSEC" ]

		dxf_table( lylist )
		@dxfcode << [ "0" , "TABLE" ]
		@dxfcode << [ "2" , "STYLE" ]
		@dxfcode << [ "70" , "1" ]
		@dxfcode << [ "0" , "STYLE" ]
		@dxfcode << [ "2" , "STANDARD" ]
		@dxfcode << [ "70" , "0" ]
		@dxfcode << [ "40" , "0.0" ]
		@dxfcode << [ "41" , "1.0" ]
		@dxfcode << [ "50" , "0.0" ]
		@dxfcode << [ "71" , "0" ]
		@dxfcode << [ "42" , "0.2" ]
		@dxfcode << [ "3" , "txt" ]
		@dxfcode << [ "4" , "" ]
		@dxfcode << [ "0" , "ENDTAB" ]
		
		@dxfcode << [ "0" , "TABLE" ]
		@dxfcode << [ "2" , "UCS" ]
		@dxfcode << [ "70" , "0" ]
		@dxfcode << [ "0" , "ENDTAB" ]
		
		@dxfcode << [ "0" , "ENDSEC" ]
		@dxfcode << [ "0" , "SECTION" ]
		###ENTITIES SECTION
		@dxfcode << [ "2" , "ENTITIES" ]
	end

	def dxf_line( p0 , p1 , layername = "SKP_LINES" , lstyle = "ByLayer" , colornum = "0" )
		#######LINE
		@dxfcode << [ "0" , "LINE" ]
		@dxfcode << [ "8" , "#{layername}" ] if not layername == ""
		@dxfcode << [ "6" , "#{lstyle}" ] if not lstyle == "ByLayer"
		@dxfcode << [ "62" , "#{colornum}" ] if not colornum == "0"
		if @units_metric == true
			@dxfcode << [ "10" , "#{p0.x.to_f.to_mm}" ]
			@dxfcode << [ "20" , "#{p0.y.to_f.to_mm}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "11" , "#{p1.x.to_f.to_mm}" ]
			@dxfcode << [ "21" , "#{p1.y.to_f.to_mm}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
		else
			@dxfcode << [ "10" , "#{p0.x.to_f}" ]
			@dxfcode << [ "20" , "#{p0.y.to_f}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "11" , "#{p1.x.to_f}" ]
			@dxfcode << [ "21" , "#{p1.y.to_f}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
		end
	end
	def dxf_text( textstr , tpt , layername = "SKP_TEXT" , textsize = "100" , lstyle = "ByLayer" , colornum = "0" )
		########TEXT
		#p "#{tpt.x.to_f.to_mm},#{tpt.y.to_f.to_mm}"
		@dxfcode << [ "0" , "TEXT" ]
		if @units_metric == true
			@dxfcode << [ "10" , "#{tpt.x.to_f.to_mm - 100}" ]
			@dxfcode << [ "20" , "#{tpt.y.to_f.to_mm}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "40" , "#{textsize}" ]
			@dxfcode << [ "11" , "#{tpt.x.to_f.to_mm}" ]
			@dxfcode << [ "21" , "#{tpt.y.to_f.to_mm}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
		else
			@dxfcode << [ "10" , "#{tpt.x.to_f - 100 / 25.4 }" ]
			@dxfcode << [ "20" , "#{tpt.y.to_f}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "40" , "#{textsize.to_f / 25.4 }" ]
			@dxfcode << [ "11" , "#{tpt.x.to_f}" ]
			@dxfcode << [ "21" , "#{tpt.y.to_f}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
		end
		@dxfcode << [ "1" , "#{textstr}" ]
		@dxfcode << [ "72" , "4" ]#横中心
		#@dxfcode << [ "73" , "2" ]#縦中央
		@dxfcode << [ "8" , "#{layername}" ] if not layername == ""
		@dxfcode << [ "6" , "#{lstyle}" ] if not lstyle == "ByLayer"
		@dxfcode << [ "62" , "#{colornum}" ] if not colornum == "0"
	end
	def dxf_solid( pts , layername = "SKP_SOLIDS" , lstyle = "ByLayer" , colornum = "9"  )
		########SOLID
		@dxfcode << [ "0" , "SOLID" ]
		@dxfcode << [ "8" , "#{layername}" ] if not layername == ""
		@dxfcode << [ "6" , "#{lstyle}" ] if not lstyle == "ByLayer"
		#@dxfcode << [ "62" , "#{colornum}" ] if not colornum == "0"
		@dxfcode << [ "62" , "9" ]
		if @units_metric == true
			@dxfcode << [ "10" , "#{pts[0].x.to_f.to_mm}" ]
			@dxfcode << [ "20" , "#{pts[0].y.to_f.to_mm}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "11" , "#{pts[1].x.to_f.to_mm}" ]
			@dxfcode << [ "21" , "#{pts[1].y.to_f.to_mm}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
			@dxfcode << [ "12" , "#{pts[2].x.to_f.to_mm}" ]
			@dxfcode << [ "22" , "#{pts[2].y.to_f.to_mm}" ]
			@dxfcode << [ "32" , "#{0.00}" ]
					#4つめの頂点は3つめと同じ数値にすると３角形となる
					#4角以上はジグザグに指定するので、ポリゴンとして3角形のほうが楽
			@dxfcode << [ "13" , "#{pts[2].x.to_f.to_mm}" ]
			@dxfcode << [ "23" , "#{pts[2].y.to_f.to_mm}" ]
			@dxfcode << [ "33" , "#{0.00}" ]
		else
			@dxfcode << [ "10" , "#{pts[0].x.to_f}" ]
			@dxfcode << [ "20" , "#{pts[0].y.to_f}" ]
			@dxfcode << [ "30" , "#{0.00}" ]
			@dxfcode << [ "11" , "#{pts[1].x.to_f}" ]
			@dxfcode << [ "21" , "#{pts[1].y.to_f}" ]
			@dxfcode << [ "31" , "#{0.00}" ]
			@dxfcode << [ "12" , "#{pts[2].x.to_f}" ]
			@dxfcode << [ "22" , "#{pts[2].y.to_f}" ]
			@dxfcode << [ "32" , "#{0.00}" ]
			@dxfcode << [ "13" , "#{pts[2].x.to_f}" ]
			@dxfcode << [ "23" , "#{pts[2].y.to_f}" ]
			@dxfcode << [ "33" , "#{0.00}" ]

		end
		#@dxfcode << [ "72" , "1" ]#横中心
		#@dxfcode << [ "73" , "2" ]#縦中央
	end
	def dxf_polyline( pts , layername = "SKP_POLYLINE" , close = true  , lstyle = "ByLayer" , colornum = "0"  )
		#######LWPOLYLINE pts
		n = pts.size
		@dxfcode << [ "0" , "LWPOLYLINE" ]
		@dxfcode << [ "8" , "#{layername}" ] if not layername == ""
		@dxfcode << [ "6" , "#{lstyle}" ] if not lstyle == "ByLayer"
		@dxfcode << [ "62" , "#{colornum}" ] if not colornum == "0"
		@dxfcode << [ "90" , "#{pts.size}" ]#頂点数
		if close == true
			@dxfcode << [ "70" , "1" ]#1:閉じた、0:閉じてないデフォルト
		end
		pts.each{|pt|
			p1 = pt.transform t
			if @units_metric == true
				@dxfcode << [ "10" , "#{p1.x.to_f.to_mm}" ]
				@dxfcode << [ "20" , "#{p1.y.to_f.to_mm}" ]
			else
				@dxfcode << [ "10" , "#{p1.x.to_f}" ]
				@dxfcode << [ "20" , "#{p1.y.to_f}" ]
			end
		}

	end
	def is_intersect_solid_plane?( sol , plane , tr )
		if sol.kind_of? Sketchup::ComponentInstance
		elsif sol.kind_of? Sketchup::Group
		elsif sol.kind_of? Sketchup::Face
		elsif sol.kind_of? Sketchup::Edge
		else
			return false
		end
		#return false if not sol.kind_of? Sketchup::ComponentInstance and not sol.kind_of? Sketchup::Group
		#p "check intersect"
		bmaxo = sol.bounds.max.transform( tr )
		bmino = sol.bounds.min.transform( tr )
		bmax = []
		bmin = []
		bmax[0] = bmaxo
		bmin[0] = bmino
		bmax[1] = [ bmaxo[0] , bmino[1] , bmaxo[2] ]
		bmin[1] = [ bmino[0] , bmaxo[1] , bmino[2] ]
		bmax[2] = [ bmino[0] , bmaxo[1] , bmaxo[2] ]
		bmin[2] = [ bmaxo[0] , bmino[1] , bmino[2] ]
		#p "name:#{sol.name}" if sol.name != nil
		(0..2).each{|i|
			#p i
			bvec = bmax[i].vector_to( bmin[i] )
			bline = [ bmax[i] , bvec ]
			ipt = Geom.intersect_line_plane(bline, plane)
			if ipt != nil
				#p "checking"
				bbfi = bmax[i].vector_to(bmin[i]).length / ( bmax[i].vector_to(ipt).length + bmin[i].vector_to(ipt).length )
				if bbfi > 0.97
					#p "true"
					return true
					#return false
				end
			end
		}
		#p "false"
		return false
	end
	def getVolume( ent )
		if ent.kind_of? Sketchup::ComponentInstance or ent.kind_of? Sketchup::Group
			return ent.volume
		else
			return nil
		end
	end
	def searchVolumetrics( velist , fclist , sectionlist , baselineslist , parent , tr , plane )

		if parent.kind_of? Sketchup::ComponentInstance
			sectionlist.each{| secname , secdef , sectr , plane |
				return if parent.definition.name == secname
			}
			#pname = "arm" if parent.definition.name == "arm"
			pents = parent.definition.entities
		else
			pents = parent.entities
		end
		
		pents.each{|ent|
			if ent.visible? == true and ent.layer.visible? == true
				if ent.kind_of? Sketchup::ComponentInstance
					if ent.name == "BST_BASELINES" or ent.definition.name == "BST_BASELINES"
						baselineslist.push [ ent , ( tr * ent.transformation  ) ]
					end
				elsif ent.kind_of? Sketchup::Group
					if ent.name == "BST_BASELINES"
						baselineslist.push [ ent , ( tr * ent.transformation  ) ]
					end
				end

				if is_intersect_solid_plane?( ent , plane , tr ) == true
					if ent.kind_of? Sketchup::ComponentInstance
						ent2 = ent.definition
					else
						ent2 = ent
					end
					v = getVolume( ent )
					
					if v == nil
						#p pname + "#{v}" if pname != nil and pname == "arm"
						#This is not Instance or Group
						if ent.kind_of? Sketchup::Face
							fclist.push [ ent , tr ]
						end
					elsif v > 0.0
						#p "#{tr} * #{ent.transformation.inverse}"
						velist.push [ ent2 , ( tr * ent.transformation  ) , parent ]
					else
						#This is Ins or Group but no volume
						#if ent.name == "BST_BASELINES" or ent.definition.name == "BST_BASELINES"
						#else
						searchVolumetrics velist , fclist , sectionlist , baselineslist , ent , ( tr * ent.transformation ), plane
						#end
					end
				end
			end
		}
	end

	def makeSolidSections
	    Sketchup.active_model.start_operation "Make SolidSections",true
		starttime = Time.now.to_f
		#Get the current selection 
	    model = Sketchup.active_model
	    ents = model.entities
	    sels = model.selection
	    sectionlist = []
	    #sectionlist = sels.find_all{|e| e.get_attribute("SECTION_SPECS","GROUP") != nil }
	    rad = model.bounds.diagonal * 4.0
	    cen = model.bounds.center
	    kilins = []
		secnamelist = []
		explist = []
		
		#scount = sels.count
		selsecs = sels.find_all{|sel| sel.kind_of? Sketchup::SectionPlane }
		if selsecs.size == 0
			#断面が選択されていない場合は全断面のリストから選択させる
			selsecs2 = Sketchup.active_model.entities.find_all{|sel| sel.kind_of? Sketchup::SectionPlane }#.find_all{|sel| sel.get_attribute( "SECTION_SPEC","GROUP","" ) != "" }
			selsecnamelist = selsecs2.map{|sel| sel.get_attribute( "SECTION_SPEC","GROUP","" ) }
			if selsecnamelist.size > 0
				selsecnamelist.push "ALL"
				prompts = [ "Section Component Name" ]
				lists = [ selsecnamelist.join("|") ]
				results = UI.inputbox prompts, [ "ALL" ] , lists , "Select Export SolidSection name"
				if results != nil
					secname = results[0]
					if secname == "ALL"
						selsecs = selsecs2
					else
						selsecs = selsecs2.find_all{|sel| sel.get_attribute( "SECTION_SPEC","GROUP","" ) == secname }
					end
				end
			else
				#一つも有効な断面がない場合はしゅうりょー
				UI.messagebox "Here is No Sections for this tool."
				return
			end
		end
		renameall = ""
		base_scname = ""
		selsecs.each{|sel|
			secname = sel.get_attribute( "SECTION_SPEC","GROUP","" )

			if sel.kind_of? Sketchup::SectionPlane
				plane = sel.get_plane.to_a
				cen2 = cen.project_to_plane( plane )
				nvec = Geom::Vector3d.new( plane[0] , plane[1] , plane[2] ).reverse
				
				nnvec = nvec.clone
				nnvec.reverse! if plane[3] < 0
				nnvec.length = plane[3].abs
				xvec = Geom::Vector3d.new( 1,0,0)
				yvec = Geom::Vector3d.new( 0,1,0)
				zvec = Geom::Vector3d.new( 0,0,1)
				if nvec.parallel?( zvec )
					#p "z parallel"
					zvec = nvec.normalize
				elsif nvec.parallel?( xvec )
					#p "x parallel"
					xvec = nvec.cross( zvec ).reverse
					yvec = zvec
					zvec = nvec.normalize
				elsif nvec.parallel?( yvec )
					#p "y parallel"
					yvec = zvec
					xvec = nvec.cross( zvec ).reverse
					zvec = nvec.normalize.reverse
				else
					#p "no parallel"
					xvec = nvec.cross( zvec ).reverse
					yvec = xvec.cross( nvec ).reverse
					zvec = nvec.normalize
				end
				#p "#{xvec} , #{yvec} , #{zvec}"
				opt = Geom::Point3d.new( nnvec[0] , nnvec[1] , nnvec[2]  )
				nvec.normalize!
				sectr = Geom::Transformation.new( xvec , yvec , zvec , opt )
				cen2.transform!( sectr.inverse )
				cen2.z = 0.0
				secname = sel.get_attribute( "SECTION_SPEC","GROUP","" )
				
				if secname != "" and selsecs.size > 1
				elsif selsecs.size == 1
					#選択した断面が１つの場合
					prompts = ["ComponentName" ]
					defaults = [secname]
					results = UI.inputbox prompts, defaults, "Export SolidSection to Component"
					if results != nil and results != false and results[0] != ""
						secname= results[0]
					else
						return
					end
				elsif selsecs.size > 1
					#選択した断面が複数の場合
					if renameall == ""
						renameall = UI.messagebox "Rename each section?", MB_YESNO
					end
					if renameall == 6#YES
						prompts = ["ComponentName" ]
						defaults = [secname]
						results = UI.inputbox prompts, defaults, "Export SolidSections to Components"
						if results != nil and results != false and results[0] != ""
							secname= results[0]
						else
							secname = ""
						end
					else
						if base_scname == ""
							base_scname = "SECTION_"
							#prompts = ["Base of Name(when it has no name)" ]
							#defaults = ["SECTION_"]
							#results = UI.inputbox prompts, defaults, "Export SolidSections to Components"
							#if results != nil and results != false and results[0] != ""
							#	base_scname = results[0]
							#else
							#	return
							#end
						end
					end
				end

				if secname != ""
				else
					secname = create_uniq_name( base_scname , secnamelist , plane )
				end
				sel.set_attribute( "SECTION_SPEC","GROUP" , secname )
				secnamelist.push secname
				secdef = model.definitions[ secname ]
				if secdef == nil
					secdef = model.definitions.add secname
				else
					secdef.entities.erase_entities secdef.entities.collect{|e| e }
				end
				cir = secdef.entities.add_ngon( cen2 , [ 0.0 , 0.0 , 1.0 ] , rad , 4 )
				secdef.entities.add_face cir
				sectionlist.push [ secname , secdef , sectr , plane ]
				sel.set_attribute "SECTION_SPEC","GROUP",secname


			end
		}
		return if sectionlist.size == 0
	    #Searching for Solids
		#velist.each{| ve , tr, parent |
		#	Sketchup.active_model.selection.add ve
		#}
		#return
		#p "calc section"
		chk_export = true
		
		mypath = File.expand_path( Sketchup.active_model.path )
		myname = "DrawingSection" ##File.basename( mypath , ".skp" )
		mydir = File.join( File.dirname( mypath ), myname )
		Dir::mkdir( mydir ) if FileTest.exists?( mydir ) != true
		
		sectionlist.each{| secname , secdef , sectr , plane |
			baselineslist = []
			section = ents.add_instance secdef,sectr
			section.set_attribute "SECTION_SPEC","GROUP" , "SECTION_GROUP"
			
			velist = []
			fclist = []
			Sketchup.status_text = "start searching solid ..."
			searchVolumetrics( velist , fclist , sectionlist , baselineslist , model , Geom::Transformation.new( [0,0,0] ) , plane )
			next if velist.size == 0 and fclist.size == 0
			
			Sketchup.status_text = "creating section with #{velist.size} volumes..."
			scgrHash = Hash.new
			velist.each{| ve , tr, parent |
				mat = ve.get_attribute( "BEAM_SPECS","MATERIAL", "" )
				hugo = ve.get_attribute( "BEAM_SPECS","HUGO", "" )
				prof = ve.get_attribute( "BEAM_SPECS","PROFILE", "" )
				clss = ve.get_attribute( "BEAM_SPECS","CLASS", "" )
				vname = ve.name
				vname = ve.definition.name if ve.kind_of? Sketchup::ComponentInstance

				mat = "Various section" if mat == nil or mat == ""
				if  scgrHash[ mat ]
					scgr , sctr = scgrHash[ mat ]
				else
					scgr = section.definition.entities.add_group
					#sctr = section.transformation * scgr.transformation
					sctr = sectr * scgr.transformation
					scgr.name = "[SOLIDSECTION]#{mat}"
					scgrHash[ mat ] = [ scgr , sctr ]
				end
				tgr = scgr.entities.add_group
				ttr = sctr * tgr.transformation
				#ve.entities.intersect_with( true , tr , scgr  , sctr ,false, section )
				ve.entities.intersect_with( true , tr , tgr  , ttr ,false, section )
				#section.definition.entities.intersect_with( true , sectr , tgr , ttr , false , ve )
				tgr.entities.each{|e| e.find_faces if e.kind_of? Sketchup::Edge }
				tgr.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc| fc.reverse! }

				if tgr.entities.count != 0
					copt = tgr.local_bounds.center
					comin = tgr.local_bounds.min
					comax = tgr.local_bounds.max
					textfeed = 150.mm
					if clss == "RC_GIRDER" or clss == "RC_COLUMN" or clss == "RC_BEAM"
						batten1 = tgr.entities.add_cline( [ comin.x , comin.y , 0 ] , [ comax.x , comax.y , 0 ] )
						batten2 = tgr.entities.add_cline [ comax.x , comin.y , 0 ] , [ comin.x , comax.y , 0 ]
						batten1.stipple = "-"
						batten2.stipple = "-"
					end
					if hugo != ""
						hugotxt = tgr.entities.add_text "tag::#{hugo}" , [ copt.x , copt.y , 0 ]
						Sketchup.active_model.layers.add "TEXT_TAG" if Sketchup.active_model.layers["TEXT_TAG"] == nil
						hugotxt.layer = Sketchup.active_model.layers["TEXT_TAG"]
					end
					if prof != ""
						proftxt = tgr.entities.add_text "profile::#{prof}" , [ copt.x , copt.y - textfeed , 0 ]
						Sketchup.active_model.layers.add "TEXT_PROFILE" if Sketchup.active_model.layers["TEXT_PROFILE"] == nil
						proftxt.layer = Sketchup.active_model.layers["TEXT_PROFILE"]
					end
					if hugo == "" and prof == "" and vname != ""
						vntxt = tgr.entities.add_text "name::#{vname}" , [ copt.x , copt.y - textfeed * 2 , 0 ]
						Sketchup.active_model.layers.add "TEXT_NAME" if Sketchup.active_model.layers["TEXT_NAME"] == nil
						vntxt.layer = Sketchup.active_model.layers["TEXT_NAME"]
					end
				end
				tgr.explode
			}
			fcgr = section.definition.entities.add_group
			fcgr.name = "LINES"
			fclist.each{| fc , ftr |
				sectr2 = ftr.inverse * sectr
				fctr = sectr2 * fcgr.transformation
				section.definition.entities.intersect_with( true , sectr2 , fcgr , fctr , false , fc )
			}
			scgrHash.keys.each{| mat |
				scgr , sctr = scgrHash[ mat ]
				sents = scgr.entities
				#sents.each{|e| e.find_faces if e.kind_of? Sketchup::Edge }
				if mat != "Various section"
					sents.intersect_with(false,sctr,scgr,sctr,false,scgr )
					delete_straylines( scgr.entities )
					unify_paint( scgr.entities )
				end
			}
			section.definition.entities.erase_entities section.definition.entities.find_all{|e| e.kind_of? Sketchup::Edge or e.kind_of? Sketchup::Face }

			#baselines = model.definitions["BST_BASELINES"]
			nvec = Geom::Vector3d.new(  plane[0] , plane[1] , plane[2] ).reverse
			nnvec = nvec.clone
			nnvec.length = plane[3]
			#if baselines != nil
			if baselineslist != []
				p "draw base lines"
				create_baseline( baselineslist , sectr , section , plane )
			end
			#section.parent.entities.erase_entities( section ) if eraseOnEnd == true
			txt_ipt = section.definition.bounds.min
			txt_ipt.z = 0
			txt_pos = "SECTION PLANE DISTANCE VECTOR:\nX=#{nnvec.x.to_l}\nY=#{nnvec.y.to_l}\nZ=#{nnvec.z.to_l}"
			#txt_pos.split("\n").each{|txt_p|
				section.definition.entities.add_text( txt_pos , txt_ipt )
			#	txt_ipt.y = txt_ipt - 300.mm
			#}
			if chk_export == true
				if Sketchup.active_model.path != ""
					Sketchup.status_text = "Exporting..."
					explist.push File.join( mydir , section.definition.name )
					if FileTest.exists?( mydir ) != true
					else
						filepath = File.join( mydir , section.definition.name + ".skp" )
						section.definition.save_as filepath
						filename =  File.join( mydir , section.definition.name + ".dxf" )
						dxf_exporter( filename , section.definition )
						p filepath
					end
				end
			else
			end
			section.erase!
		}
		if kilins.size >= 1
			Sketchup.status_text = "Deleting temporary elements..."
			ents.erase_entities kilins
		end
		Sketchup.status_text = "finish!!"

	    Sketchup.active_model.commit_operation
		wastetime = Time.now.to_f - starttime
		if Sketchup.active_model.path == ""
			UI.messagebox "SectionDrawing did not save as SKP because this model did not save."
		elsif FileTest.exists?( mydir ) != true
			UI.messagebox "This script can not create drawing folder.\nYou may save this skp to the path with only alphabetical and numeric characters"
		else
			msg = "Finished.\n"
			msg << "Wasted time is #{wastetime} sec\n"
			explist.each{|fpath|
				msg << fpath.gsub(/\\/,"\\\\") + "\n"
			}
			UI.messagebox msg
		end
	end

	def create_uniq_name( bname , namelist , plane = nil )
		if plane != nil
			plvec = Geom::Vector3d.new( plane[0] , plane[1] , plane[2] )
			if plvec.parallel?( Geom::Vector3d.new( 1,0,0 ) )
				bname2 = "#{bname}XX_#{plane[3].to_l.to_i}_"
			elsif plvec.parallel?( Geom::Vector3d.new( 0,1,0 ) )
				bname2 = "#{bname}YY_#{plane[3].to_l.to_i}_"
			elsif plvec.parallel?( Geom::Vector3d.new( 0,0,1 ) )
				bname2 = "#{bname}ZZ_#{plane[3].to_l.to_i}_"
			else
				bname2 = "#{bname}XYZ_#{plane[3].to_l.to_i}_"
			end
		else
			bname2 = bname
		end
		999.times{|i|
			nname = "#{bname2}#{ i + 1 }"
			if namelist.index( nname ) == nil
				return nname
			end
		}
	end
	def create_baseline( baselineslist , sectr , section , plane )
		section.definition.invalidate_bounds
		bbsecmaxy = section.bounds.max.transform( section.transformation.inverse ).y
		bbsecminy = section.bounds.min.transform( section.transformation.inverse ).y
		nvec = Geom::Vector3d.new(  plane[0] , plane[1] , plane[2] ).reverse
			baselineslist.each{|bgrp , btr |
				#btr = bins.transformation
				if bgrp.kind_of? Sketchup::Group
					bents = bgrp.entities
				elsif bgrp.kind_of? Sketchup::ComponentInstance
					bents = bgrp.definition.entities
				end
				Sketchup.status_text = "draw baselines..."

				blines = []
				bents.each{|e|
					if e.kind_of? Sketchup::ConstructionLine or e.kind_of? Sketchup::Edge
						stip ="-.-"
						if e.kind_of? Sketchup::ConstructionLine
							st = e.start
							en = e.end
							cpos = e.position
							cdir = e.direction
							stip = e.stipple
						elsif e.kind_of? Sketchup::Edge
							st = e.start.position
							en = e.end.position
							cpos = st
							cdir = st.vector_to( en )
						end
						zveci = Geom::Vector3d.new( 0,0,100 )
						bipt1 = nil
						bipt2 = nil
						bipt3 = nil
						bipt4 = nil
						bipt5 = nil
						bipt6 = nil
						bipt7 = nil
						if st == nil
						else
							st.transform!( btr )
							en.transform!( btr )

							line1 = [ st , zveci ]
							line2 = [ en , zveci ]
							line3 = [ st , st.vector_to( en ) ]
							line4 = [ st , nvec ]
							line5 = [ en , nvec ]
							bipt1 = Geom.intersect_line_plane( line1 , plane )
							bipt2 = Geom.intersect_line_plane( line2 , plane )
							bipt3 = Geom.intersect_line_plane( line3 , plane )
							bipt4 = Geom.intersect_line_plane( line4 , plane )
							bipt5 = Geom.intersect_line_plane( line5 , plane )
						end
						cpos.transform!( btr )
						cdir.transform!( btr )
						line6 = [ cpos , zveci ]
						line7 = [ cpos , cdir ]
						line8 = [ cpos , nvec ]
						bipt6 = Geom.intersect_line_plane( line6 , plane )
						bipt7 = Geom.intersect_line_plane( line7 , plane )
						bipt8 = Geom.intersect_line_plane( line8 , plane )
						if bipt1 != nil and bipt2 != nil
							prst = bipt1.transform( sectr.inverse )
							pren = bipt2.transform( sectr.inverse )
							prst.z = 0
							pren.z = 0

							bline = section.definition.entities.add_cline( prst , pren )
							bline.stipple = stip if stip != nil
							blines.push bline
						elsif bipt6 != nil
							prst = bipt6.transform( sectr.inverse )
							prdir = cdir.transform( sectr.inverse )
							prst.z = 0
							prdir.z = 0
							bline = section.definition.entities.add_cline( prst , prdir )
							bline.stipple = stip if stip != nil
							blines.push bline
						elsif bipt3 != nil
							prst = bipt3.transform( sectr.inverse )
							pren = bipt3.transform( sectr.inverse )
							prst.y = bbsecminy
							pren.y = bbsecmaxy
							prst.z = 0
							pren.z = 0

							bline = section.definition.entities.add_cline( prst , pren )
							bline.stipple = stip if stip != nil
							blines.push bline
						elsif bipt7 != nil
							prst = bipt7.transform( sectr.inverse )
							pren = bipt7.transform( sectr.inverse )
							prst.y = bbsecminy
							pren.y = bbsecmaxy
							prst.z = 0
							pren.z = 0
							bline = section.definition.entities.add_cline( prst , pren )
							bline.stipple = stip if stip != nil
							blines.push bline
						elsif bipt4 != nil and bipt5 != nil
							prst = bipt4.transform( sectr.inverse )
							pren = bipt5.transform( sectr.inverse )
							prst.z = 0
							pren.z = 0
							bline = section.definition.entities.add_cline( prst , pren )
							bline.stipple = stip if stip != nil
							blines.push bline
						elsif bipt8 != nil
							prst = bipt8.transform( sectr.inverse )
							prdir = cdir.transform( sectr.inverse )
							prst.z = 0
							prdir.z = 0
							bline = section.definition.entities.add_cline( prst , prdir )
							bline.stipple = stip if stip != nil
							blines.push bline
						end

					end
				}

			}
	end
	def get_cline_st_en( e , tr )
		model = Sketchup.active_model
		mbbs = model.bounds
		if e.kind_of? Sketchup::ConstructionLine
			st = e.start
			en = e.end
			if st == nil
				cli = [ e.position.transform!( tr ) , e.direction.transform!( tr ) ]
				
			else
				st.transform!( tr )
				en.transform!( tr )
			end
		end
		return st , en
	end
	def unify_paint( sents )
		klist = sents.find_all{|e| e.kind_of? Sketchup::Edge }
		#p "#{klist}"
		klist.each{|e|
			if e.faces.size >= 2
				e.hidden = true
				#p "unify"
			end
		}

	end
	def delete_straylines( sents )
		3.times{
			kilist = []
			sents.each{|e|
				if e.kind_of? Sketchup::Edge
					kilist.push e if e.start.edges.size == 1 or e.end.edges.size == 1
				end
			}
			sents.erase_entities kilist if kilist.size != 0
		}
	end
	def extend_ptss_with_distance( ed , dist = 100.mm )
		return nil if ed.curve != nil
		vt1 = ed.start
		vt2 = ed.other_vertex( vt1 )
		pt1 = vt1.position
		pt2 = vt2.position
		vec1 = pt2.vector_to( pt1 )
		vec2 = pt1.vector_to( pt2 )

		if ed.start.edges.size == 1
			if vec1.length != 0
				vec1.length = dist
				pt1 = pt1 + vec1
				chk = true
			end
		end
		if ed.end.edges.size == 1
			if vec2.length != 0
				vec2.length = dist
				pt2 = pt2 + vec2
				chk = true
			end
		end
		
		return [ pt1,pt2 ]
	end
	def change_section_name()
		sels = Sketchup.active_model.selection
		#選択した断面が１つの場合
		sels.each{|sel|
			if sel.kind_of? Sketchup::SectionPlane
				secname = sel.get_attribute( "SECTION_SPEC","GROUP","" )
				prompts = ["ComponentName" ]
				defaults = [secname]
				results = UI.inputbox prompts, defaults, "Export SolidSection to Component"
				if results != nil and results != false and results[0] != ""
					sel.set_attribute( "SECTION_SPEC","GROUP",results[0] )
				end
			end
		}
	end
end
unless( file_loaded?( 'create_section_drawings.rb' ) )
	tak_mss = TAK_MSS.new
	tak_mss_menu = UI.menu("Plugins").add_submenu("Section Drawing")
	tak_mss_menu.add_item("Create Section Drawing" ) { tak_mss.makeSolidSections }
	tak_mss_menu.add_item("Change Section Name") { tak_mss.change_section_name }
	tak_mss_menu.add_item("About This") { tak_mss.show_about_this }

	UI.add_context_menu_handler {|menu|
		sel=Sketchup.active_model.selection.first
		if sel != nil and sel.class==Sketchup::SectionPlane
				menu.add_separator
					tak_mss_conmenu = menu.add_submenu("Section Drawing")
					tak_mss_conmenu.add_item("Create Section Drawing") { tak_mss.makeSolidSections }
					tak_mss_conmenu.add_item("Change Section Name") { tak_mss.change_section_name }
				menu.add_separator
		end
	}
end

file_loaded('create_section_drawings.rb')

